/*
 * save_sleep	Save alarm context, sleep, restore it.
 *
 * Version:	@(#)savesleep.c	1.0.0	03/17/94
 *
 * Author:      lilo <TaRDiS@MBS.Telesys.UTexas.EDU>
 *
 *		Copyright 1994 by lilo <TaRDiS@MBS.Telesys.UTexas.EDU.
 *		All rights reserved.  Licensing information follows.
 *
 *		This program is free software; you can redistribute it
 *		and/or  modify it under  the terms of  the GNU General
 *		Public  License as  published  by  the  Free  Software
 *		Foundation;  either  version 2 of the License, or  (at
 *		your option) any later version.
 */
#include "dip.h"

void save_sleep(int sec)
{
	void (*oldsig) (int);
	int oldalarm;

	/* Turn off alarm timer and signal setting; save old values. */
	
	oldalarm=alarm(0);
	oldsig=signal(SIGALRM, SIG_IGN);
	
	/* If old alarm timer value was nonzero and no time is left  */
	/* after the sleep, restore old signal and process the alarm */
	/* signal *now* as specified by that value.                  */
	
	if (oldalarm) {
	  if (oldalarm<=sec) {
	  	(void) signal(SIGALRM, oldsig);
	  	(void) kill(getpid(), SIGALRM);
	  }
	}
	
	/* Otherwise perform the sleep.  Restore the timer to its   */
	/* prior value, minus the length of time we slept.  Then    */
	/* restore the signal and quit.                             */
	
	sleep(sec);	
	(void) alarm(oldalarm-sec);
	(void) signal(SIGALRM, oldsig);
}
